#ifndef LITTLE_RT_H
#define LITTLE_RT_H

#include <little/little.h>

/************************************
 * Includes needed by everyone ...  *
 ************************************/

#include <little/little_error.h>
#include <little/little_gc.h>
#include <little/ltl_packed_array.h>

#ifdef __cplusplus
extern "C" {
#endif

/************************************
 * LITTLE classes.                  *
 ************************************/

/*
 * little.lang package
 */
#define ARRAY_CLASS		"little/lang/Array"
#define ANCITER_CLASS		"little/lang/AncestorIterator"
#define ARGITER_CLASS		"little/lang/ArgumentIterator"
#define ATTRITER_CLASS		"little/lang/AttributeIterator"
#define CHAR_CLASS		"little/lang/Char"
#define CLASSITER_CLASS		"little/lang/ClassIterator"
#define CODEREF_CLASS		"little/lang/CodeRef"
#define CONTAINER_CLASS		"little/lang/Container"
#define DESCITER_CLASS		"little/lang/DescendantIterator"
#define FLOAT_CLASS		"little/lang/Float"
#define EXCEPTION_CLASS		"little/lang/Exception"
#define HEAP_CLASS		"little/lang/Heap"
#define INSTANTIABLE_CLASS	"little/lang/Instantiable"
#define METHOD_CLASS		"little/lang/Method"
#define METHODITER_CLASS	"little/lang/MethodIterator"
#define STRBUF_CLASS		"little/lang/StringBuffer"
#define STRING_CLASS		"little/lang/String"

/*
 * little.io package
 */
#define DIRITER_CLASS	"little/io/DirectoryIterator"
#define FILE_CLASS	"little/io/File"
#define FILEATTR_CLASS	"little/io/FileAttributes"


/************************************
 * Utility macros ...               *
 ************************************/

#define LTL_MAXSTRLEN 1000

/*
 * StringBuffer is assumed to have PChar instance as field #0
 * (StringBuffer is defined 'sticky').
 */
#define LTL_STRBUF_PCHAR(bp) ((char *) (bp)->fields[0].fields)

void little_system_initargs(int,int,char **);
void little_system_initprops();
int little_system_argc();
char *little_system_arg(int);
char **little_system_argv();
int little_system_vmargc();
char **little_system_vmargv();
void little_system_putprop(ltl_env_t *,const char *,const char *);
const char *little_system_getprop(ltl_env_t *,const char *);

#ifdef __cplusplus
}
#endif

#endif
